## mingw-w64-gammaray-3.1.0-2.src.tar.zst

=== core/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2012 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

set(gammaray_srcs
    ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp
    abstractbindingprovider.cpp
    abstractbindingprovider.h
    aggregatedpropertymodel.cpp
    aggregatedpropertymodel.h
    associativepropertyadaptor.cpp
    associativepropertyadaptor.h
    attributemodel.cpp
    attributemodel.h
    bindingaggregator.cpp
    bindingaggregator.h
    bindingnode.cpp
    bindingnode.h
    classesiconsrepositoryserver.cpp
    classesiconsrepositoryserver.h
    dynamicpropertyadaptor.cpp
    dynamicpropertyadaptor.h
    enumrepositoryserver.cpp
    enumrepositoryserver.h
    enumutil.cpp
    enumutil.h
    execution.cpp
    execution.h
    favoriteobject.cpp
    favoriteobject.h
    jsonpropertyadaptor.cpp
    jsonpropertyadaptor.h
    metaobject.cpp
    metaobject.h
    metaobjectregistry.cpp
    metaobjectregistry.h
    metaobjectrepository.cpp
    metaobjectrepository.h
    metaproperty.cpp
    metaproperty.h
    metapropertyadaptor.cpp
    metapropertyadaptor.h
    methodargumentmodel.cpp
    methodargumentmodel.h
    multisignalmapper.cpp
    multisignalmapper.h
    objectclassinfomodel.cpp
    objectclassinfomodel.h
    objectdataprovider.cpp
    objectdataprovider.h
    objectenummodel.cpp
    objectenummodel.h
    objectinstance.cpp
    objectinstance.h
    objectlistmodel.cpp
    objectlistmodel.h
    objectmethodmodel.cpp
    objectmethodmodel.h
    objecttreemodel.cpp
    objecttreemodel.h
    objecttypefilterproxymodel.cpp
    objecttypefilterproxymodel.h
    paintanalyzer.cpp
    paintanalyzer.h
    paintbuffer.cpp
    paintbuffer.h
    paintbuffermodel.cpp
    paintbuffermodel.h
    painterprofilingreplayer.cpp
    painterprofilingreplayer.h
    probe.cpp
    probe.h
    probecontroller.cpp
    probecontroller.h
    probeguard.cpp
    probeguard.h
    probesettings.cpp
    probesettings.h
    problemcollector.cpp
    problemcollector.h
    propertyadaptor.cpp
    propertyadaptor.h
    propertyadaptorfactory.cpp
    propertyadaptorfactory.h
    propertyaggregator.cpp
    propertyaggregator.h
    propertycontroller.cpp
    propertycontroller.h
    propertycontrollerextension.cpp
    propertycontrollerextension.h
    propertydata.cpp
    propertydata.h
    propertyfilter.cpp
    propertyfilter.h
    proxytoolfactory.cpp
    proxytoolfactory.h
    qmetaobjectvalidator.cpp
    qmetaobjectvalidator.h
    qmetapropertyadaptor.cpp
    qmetapropertyadaptor.h
    remote/localserverdevice.cpp
    remote/localserverdevice.h
    remote/remotemodelserver.cpp
    remote/remotemodelserver.h
    remote/selectionmodelserver.cpp
    remote/selectionmodelserver.h
    remote/server.cpp
    remote/server.h
    remote/serverdevice.cpp
    remote/serverdevice.h
    remote/serverproxymodel.cpp
    remote/serverproxymodel.h
    remote/tcpserverdevice.cpp
    remote/tcpserverdevice.h
    remoteviewserver.cpp
    remoteviewserver.h
    sequentialpropertyadaptor.cpp
    sequentialpropertyadaptor.h
    signalspycallbackset.cpp
    signalspycallbackset.h
    singlecolumnobjectproxymodel.cpp
    singlecolumnobjectproxymodel.h
    stacktracemodel.cpp
    stacktracemodel.h
    toolfactory.cpp
    toolfactory.h
    toolmanager.cpp
    toolmanager.h
    toolpluginerrormodel.cpp
    toolpluginerrormodel.h
    toolpluginmodel.cpp
    toolpluginmodel.h
    tools/messagehandler/messagehandler.cpp
    tools/messagehandler/messagehandler.h
    tools/messagehandler/messagemodel.cpp
    tools/messagehandler/messagemodel.h
    tools/metaobjectbrowser/metaobjectbrowser.cpp
    tools/metaobjectbrowser/metaobjectbrowser.h
    tools/metaobjectbrowser/metaobjecttreemodel.cpp
    tools/metaobjectbrowser/metaobjecttreemodel.h
    tools/metatypebrowser/metatypebrowser.cpp
    tools/metatypebrowser/metatypebrowser.h
    tools/metatypebrowser/metatypesmodel.cpp
    tools/metatypebrowser/metatypesmodel.h
    tools/objectinspector/abstractconnectionsmodel.cpp
    tools/objectinspector/abstractconnectionsmodel.h
    tools/objectinspector/applicationattributeextension.cpp
    tools/objectinspector/applicationattributeextension.h
    tools/objectinspector/bindingextension.cpp
    tools/objectinspector/bindingextension.h
    tools/objectinspector/bindingmodel.cpp
    tools/objectinspector/bindingmodel.h
    tools/objectinspector/classinfoextension.cpp
    tools/objectinspector/classinfoextension.h
    tools/objectinspector/connectionsextension.cpp
    tools/objectinspector/connectionsextension.h
    tools/objectinspector/enumsextension.cpp
    tools/objectinspector/enumsextension.h
    tools/objectinspector/inboundconnectionsmodel.cpp
    tools/objectinspector/inboundconnectionsmodel.h
    tools/objectinspector/methodsextension.cpp
    tools/objectinspector/methodsextension.h
    tools/objectinspector/objectinspector.cpp
    tools/objectinspector/objectinspector.h
    tools/objectinspector/outboundconnectionsmodel.cpp
    tools/objectinspector/outboundconnectionsmodel.h
    tools/objectinspector/propertiesextension.cpp
    tools/objectinspector/propertiesextension.h
    tools/objectinspector/stacktraceextension.cpp
    tools/objectinspector/stacktraceextension.h
    tools/problemreporter/availablecheckersmodel.cpp
    tools/problemreporter/availablecheckersmodel.h
    tools/problemreporter/problemmodel.cpp
    tools/problemreporter/problemmodel.h
    tools/problemreporter/problemreporter.cpp
    tools/problemreporter/problemreporter.h
    tools/resourcebrowser/resourcebrowser.cpp
    tools/resourcebrowser/resourcebrowser.h
    tools/resourcebrowser/resourcefiltermodel.cpp
    tools/resourcebrowser/resourcefiltermodel.h
    util.cpp
    util.h
    varianthandler.cpp
    varianthandler.h
    ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc
)

set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/loggingcategorymodel.cpp)

include_directories(${CMAKE_SOURCE_DIR}/3rdparty/qt/5.5/)
list(APPEND gammaray_srcs ${CMAKE_SOURCE_DIR}/3rdparty/qt/5.5/private/qpaintbuffer.cpp)

if(WIN32 AND NOT MINGW)
    list(APPEND gammaray_srcs ${CMAKE_SOURCE_DIR}/3rdparty/StackWalker/StackWalker.cpp)
endif()

# core lib
add_library(
    gammaray_core
    ${GAMMARAY_LIBRARY_TYPE} ${gammaray_srcs}
)
generate_export_header(gammaray_core)
target_compile_features(gammaray_core PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})

gammaray_target_relocatable_interfaces(gammaray_core_ipaths)
target_include_directories(
    gammaray_core
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<INSTALL_INTERFACE:${gammaray_core_ipaths}>
)
target_include_directories(
    gammaray_core SYSTEM
    PRIVATE ${CMAKE_SOURCE_DIR}/3rdparty/backward-cpp
)
target_link_libraries(
    gammaray_core
    PUBLIC gammaray_common
    PRIVATE $<BUILD_INTERFACE:gammaray_common_internal>
            gammaray_kitemmodels
            ${CMAKE_DL_LIBS}
            Qt::CorePrivate
            Qt::GuiPrivate
)
if(GAMMARAY_USE_PCH)
    target_precompile_headers(gammaray_core REUSE_FROM gammaray_pch_core_gui)
endif()

# cmake-lint: disable=E1120
set_target_properties(
    gammaray_core PROPERTIES ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES} OUTPUT_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
)
gammaray_set_rpath(gammaray_core ${LIB_INSTALL_DIR})

target_link_libraries(
    gammaray_core
    PUBLIC Qt::Core
    PRIVATE Qt::Gui Qt::GuiPrivate Qt::Network
)
if(TARGET Qt::AndroidExtras)
    target_link_libraries(gammaray_core PRIVATE Qt::AndroidExtras)
endif()

add_backward(gammaray_core)

if(NOT GAMMARAY_PROBE_ONLY_BUILD)
    install(
        TARGETS gammaray_core
        EXPORT GammaRayTargets
        ${INSTALL_TARGETS_DEFAULT_ARGS}
    )

    gammaray_install_headers(
        ${CMAKE_CURRENT_BINARY_DIR}/gammaray_core_export.h
        enumrepositoryserver.h
        enumutil.h
        metaobject.h
        metaobjectrepository.h
        metaproperty.h
        objectmodelbase.h
        objectdataprovider.h
        objecttypefilterproxymodel.h
        probe.h
        probecontroller.h
        propertycontroller.h
        propertycontrollerextension.h
        signalspycallbackset.h
        singlecolumnobjectproxymodel.h
        toolfactory.h
        typetraits.h
        util.h
        varianthandler.h
        remote/server.h
    )

    ecm_generate_pri_file(
        BASE_NAME
        GammaRayCore
        LIB_NAME
        gammaray_core-${GAMMARAY_PROBE_ABI}
        DEPS
        "core gui GammaRayCommon"
        FILENAME_VAR
        PRI_FILENAME
        INCLUDE_INSTALL_DIR
        ${INCLUDE_INSTALL_DIR}
    )

    install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
    if(GAMMARAY_STATIC_PROBE)
        gammaray_install_headers(staticprobe.h)
    endif()
else()
    install(TARGETS gammaray_core ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
if(MSVC)
    install(
        FILES "$<TARGET_PDB_FILE_DIR:gammaray_core>/$<TARGET_PDB_FILE_NAME:gammaray_core>"
        DESTINATION ${BIN_INSTALL_DIR}
        CONFIGURATIONS Debug RelWithDebInfo
    )
endif()

=== docs/man/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2016 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

if(UNIX)
    find_program(POD2MAN_EXECUTABLE pod2man)
    gammaray_add_dummy_package(pod2man POD2MAN_EXECUTABLE)
    set_package_properties(
        pod2man PROPERTIES
        TYPE RECOMMENDED
        DESCRIPTION "Man page generator"
        PURPOSE "Generate GammaRay man pages."
    )

    if(POD2MAN_EXECUTABLE)
        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1
            COMMAND ${POD2MAN_EXECUTABLE} -c "KDAB" -r "\"${GAMMARAY_VERSION}\"" -s 1
                    ${CMAKE_CURRENT_SOURCE_DIR}/gammaray.pod ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1
            DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gammaray.pod
            COMMENT "Generate the GammaRay man page"
        )
        add_custom_target(
            man ALL
            DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1
            COMMENT "Target to generate the man pages"
        )

        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1 DESTINATION ${MAN_INSTALL_DIR})
    endif()
endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=gammaray
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.1.0
pkgrel=2
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
pkgdesc="A tool for examining the internals of a Qt application and to some extent also manipulate it"
url="https://www.kdab.com/gammaray/"
msys2_repository_url="https://github.com/KDAB/GammaRay"
msys2_references=(
  'archlinux: gammaray'
)
license=('spdx:GPL-2.0-or-later')
provides=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-dlfcn")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
             "${MINGW_PACKAGE_PREFIX}-qt6-3d"
             "${MINGW_PACKAGE_PREFIX}-qt6-connectivity"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-location"
             "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
             "${MINGW_PACKAGE_PREFIX}-qt6-scxml"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-kcoreaddons-qt5"
             "${MINGW_PACKAGE_PREFIX}-kdstatemachineeditor-qt5"
             "${MINGW_PACKAGE_PREFIX}-qt5-3d"
             "${MINGW_PACKAGE_PREFIX}-qt5-connectivity"
             "${MINGW_PACKAGE_PREFIX}-qt5-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt5-gamepad"
             "${MINGW_PACKAGE_PREFIX}-qt5-location"
             "${MINGW_PACKAGE_PREFIX}-qt5-script"
             "${MINGW_PACKAGE_PREFIX}-qt5-scxml"
             "${MINGW_PACKAGE_PREFIX}-qt5-svg"
             "${MINGW_PACKAGE_PREFIX}-qt5-tools"
             "${MINGW_PACKAGE_PREFIX}-syntax-highlighting-qt5"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-glslang")
optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-3d: 3D plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Quick/Qml and positioning plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-scxml: state machine viewer plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-connectivity: bluetooth plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-positioning: positioning plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-svg: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-tools: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-3d: Qt5 3D plugins"
            "${MINGW_PACKAGE_PREFIX}-qt5-base: Qt5 applications support"
            "${MINGW_PACKAGE_PREFIX}-qt5-declarative: Qt5 Quick/Qml and positioning plugins"
            "${MINGW_PACKAGE_PREFIX}-qt5-scxml: Qt5 state machine viewer plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-connectivity: Qt5 bluetooth plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-script: Qt5 script engine debugger plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-location: Qt5 positioning plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-svg: Qt5 Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-tools: Qt5 Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-kcoreaddons-qt5: KJob tracker plugin"
            "${MINGW_PACKAGE_PREFIX}-kdstatemachineeditor-qt5: ")
source=(${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        003-win32-not-elf.patch
        004-files-layout.patch
        005-fix-dll-naming.patch)
sha256sums=('6b8e3005105bd9f7553a64fab68e724840b5cb411f3115f5a8577f999b2e9254'
            'b13e2caa213d0b83a37c72e57bb5dc6e1d7e3d06d3f3031ad8931df3059cd9c0'
            '5c7e44e3fa6e914e369c2149fe9ca4b9e133f6753c7c6539cef66c9aeac5da21'
            '1d4ebacca418f8f1c9df0c4c438742e63d5d372d37d1605ecf9b478b098155eb')
validpgpkeys=(E86C000370B1B9E2A9191AD53DBFB6882C9358FB) # KDAB Products <info@kdab.com>

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    003-win32-not-elf.patch \
    004-files-layout.patch \
    005-fix-dll-naming.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _extra_config+=("-DSTACK_DETAILS_BFD=ON")
  else
    _extra_config+=("-DSTACK_DETAILS_BFD=OFF")
  fi

  for _qt_ver in 5 6; do
    if [[ ${_qt_ver} == 5 ]]; then
      _include_dir=include
    else
      _include_dir=include/qt6
    fi
    MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DECM_MKSPECS_INSTALL_DIR=;-DPLUGIN_INSTALL_DIR=;" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_INSTALL_OLDINCLUDEDIR=${MINGW_PREFIX}/${_include_dir} \
      -DTRANSLATION_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/translations \
      -DPLUGIN_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/plugins/gammaray \
      -DECM_MKSPECS_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/mkspecs/modules \
      -DGAMMARAY_INSTALL_QT_LAYOUT=ON \
      -DGAMMARAY_MULTI_BUILD=FALSE \
      -DGAMMARAY_WITH_KDSME=OFF \
      -DSTACK_DETAILS_AUTO_DETECT=OFF \
      -DMINGW_MSVCR_LIBRARY="" \
      -DQT_VERSION_MAJOR=${_qt_ver} \
      "${_extra_config[@]}" \
      -S ${_realname}-${pkgver} \
      -B build-${MSYSTEM}-qt${_qt_ver}

    ${MINGW_PREFIX}/bin/cmake.exe --build build-${MSYSTEM}-qt${_qt_ver}
  done
}

package() {
  for _qt_ver in 5 6; do
    DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}-qt${_qt_ver}
  done

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
